//------------------------------------------------------------------------------
// <autogenerated>
//     This code was generated by a tool.
//     Runtime Version: 1.1.4322.2032
//
//     Changes to this file may cause incorrect behavior and will be lost if 
//     the code is regenerated.
// </autogenerated>
//------------------------------------------------------------------------------
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;

/// <summary>
/// This class handles DataTables
/// </summary>
/// <remarks>
/// 	created by - Forstmeier Peter
/// 	created on - 23.10.2005 15:12:06///
///</remarks>

namespace SharpReportCore {

	internal sealed class TableStrategy : BaseListStrategy,IEnumerable<BaseComparer> {
		
		DataTable table;
		DataView view = new DataView();
		DataRowView row;
		
		#region Constructor
		
		public TableStrategy(DataTable table,ReportSettings reportSettings):base(reportSettings) {
			if (table == null) {
				throw new ArgumentNullException("table");
			}
			this.table = table;
			view = this.table.DefaultView;
		}
		
		#endregion
		
		#region Building Index list
	
		private SharpIndexCollection  BuildSortIndex(ColumnCollection col) {
			SharpIndexCollection arrayList = new SharpIndexCollection();
			try {
				for (int rowIndex = 0; rowIndex < this.view.Count; rowIndex++){
					DataRowView rowItem = this.view[rowIndex];
					object[] values = new object[col.Count];
					for (int criteriaIndex = 0; criteriaIndex < col.Count; criteriaIndex++){
						AbstractColumn c = (AbstractColumn)col[criteriaIndex];
						object value = rowItem[c.ColumnName];

						if (value != null && value != DBNull.Value){
							if (!(value is IComparable)){
								throw new InvalidOperationException(value.ToString());
							}
							
							values[criteriaIndex] = value;
						}   else {
							values[criteriaIndex] = DBNull.Value;
						}
					}
					arrayList.Add(new SortComparer(col, rowIndex, values));
				}
			} catch (Exception) {
				throw;
			}

			arrayList.Sort();
			return arrayList;
		}
		
		// if we have no sorting, we build the indexlist as well
			
		private SharpIndexCollection IndexBuilder(IndexerBuilderEventHandler indexer,ColumnCollection col) {
			SharpIndexCollection arrayList = new SharpIndexCollection();
			for (int rowIndex = 0; rowIndex < this.view.Count; rowIndex++){
				object[] values = new object[1];
				BaseComparer bc = indexer(col,rowIndex,values);
				arrayList.Add(bc);
			}
			return arrayList;
		}
		
		
		#endregion
		
		#region Grouping
		
		private void BuildGroup(){
			try {
				SharpIndexCollection groupedArray = new SharpIndexCollection();
				
				if (base.ReportSettings.GroupColumnsCollection != null) {
					if (base.ReportSettings.GroupColumnsCollection.Count > 0) {
					groupedArray = this.BuildSortIndex (base.ReportSettings.GroupColumnsCollection);
//					
//						SharpReportCore.IndexerDelegate sort = new SharpReportCore.IndexerDelegate(BaseListStrategy.SortedIndexBuilder);
//					groupedArray = this.IndexBuilder(sort,base.ReportSettings.GroupColumnsCollection);
					}
				}

				base.MakeGroupedIndexList (groupedArray);

//				System.Console.WriteLine("GroupedList with {0} elements",base.IndexList.Count);
			/*
				foreach (BaseComparer bc in this.IndexList) {
					GroupSeperator gs = bc as GroupSeperator;
					
					if (gs != null) {
//						System.Console.WriteLine("Group Header <{0}> with <{1}> Childs ",gs.ObjectArray[0].ToString(),gs.GetChildren.Count);
						if (gs.HasChildren) {
							foreach (SortComparer sc in gs.GetChildren) {
								
								System.Console.WriteLine("\t {0}   {1}",sc.ListIndex,sc.ObjectArray[0].ToString());										}
						}
					} else {
						SortComparer sc = bc as SortComparer;
						
						if (sc != null) {
							System.Console.WriteLine("\t Child {0}",sc.ObjectArray[0].ToString());
						}
					}
					
				}
				*/
			} catch (Exception e) {
				System.Console.WriteLine("BuildGroup {0}",e.Message);
				throw;
			}
		}
		
	
		#endregion
		
		#region IEnumerable

		IEnumerator IEnumerable.GetEnumerator(){
			System.Console.WriteLine("TableStrategy:IEnumerable.GetEnumerator()");
			return((IEnumerable<BaseComparer>)this).GetEnumerator();
		}
		
		IEnumerator<BaseComparer> IEnumerable<BaseComparer>.GetEnumerator()
		{
			System.Console.WriteLine("\tTableStrategy:IEnumerable<BaseComparer>.GetEnumerator()");
			IEnumerable<BaseComparer> e = (IEnumerable<BaseComparer>)base.IndexList;
			return e.GetEnumerator();
		}
		#endregion
		
		
		
		#region IEnumerator
		public override bool MoveNext(){
			return base.MoveNext();
		}
		
		public override void Reset() {
			base.Reset();
			this.view.Sort = "";
			this.view.RowFilter = "";
			
		}
		
		public override object Current{
			get {
				if (base.CurrentRow < 0) {
					return null;
				} else {
					return row = this.view[((BaseComparer)base.IndexList[base.CurrentRow]).ListIndex];
				}
			}
		}
		
		#endregion
		
		
		#region IDataViewStrategy interface implementation
		
		public override void Bind() {
			base.Bind();

			if (base.ReportSettings.GroupColumnsCollection.Count > 0) {
				this.Group ();
				Reset();
				return;
			}
			
				this.Sort ();

			Reset();
		}
	
		public override  void Sort () {
			base.Sort();
			if ((base.ReportSettings.SortColumnCollection != null)) {
				if (base.ReportSettings.SortColumnCollection.Count > 0) {
					base.IndexList = this.BuildSortIndex (base.ReportSettings.SortColumnCollection);
					
//					SharpReportCore.IndexerDelegate sort = new SharpReportCore.IndexerDelegate(BaseListStrategy.SortedIndexBuilder);
//					base.IndexList = this.IndexBuilder(sort,base.ReportSettings.SortColumnCollection);
					base.IsSorted = true;
				} else {
					SharpReportCore.IndexerBuilderEventHandler unsort = new SharpReportCore.IndexerBuilderEventHandler(BaseListStrategy.PlainIndexBuilder);
					base.IndexList = this.IndexBuilder(unsort,base.ReportSettings.SortColumnCollection);
					base.IsSorted = false;
				}
			}
		}
		
		protected override void Group() {
			if (base.ReportSettings.GroupColumnsCollection.Count == 0) {
				return;
			}
			this.BuildGroup();
			base.Group();
		}
		
		public override void Fill (IItemRenderer item) {
			try {
				base.Fill(item);
				if (this.Current == null) {
					System.Console.WriteLine("row is null");
				}
				if (this.row != null) {
					BaseDataItem baseDataItem = item as BaseDataItem;
					if (baseDataItem != null) {
						baseDataItem.DbValue = row[baseDataItem.ColumnName].ToString();
					}
				}
			} catch (Exception) {
				throw;
			}
		}
			
	
		public override ColumnCollection AvailableFields {
			get {
				ColumnCollection c = base.AvailableFields;
				DataTable tbl = view.Table;
				for (int i = 0;i < tbl.Columns.Count ;i ++ ) {
					DataColumn col = tbl.Columns[i];
					c.Add (new AbstractColumn(col.ColumnName,col.DataType));
					}
				return c;
			}
		}
		
		
		public override int Count {
			get {
				return this.IndexList.Count;
//				return this.view.Count;
			}
		}
		
		public override int CurrentRow {
			get{
				return base.IndexList.CurrentPosition;
			}
			
			/*
			set {
				base.CurrentRow = value;
				if ((value > -1) && (value < base.IndexList.Count)){
					BaseComparer bc = (BaseComparer)base.IndexList[value];
					
					GroupSeperator sep = bc as GroupSeperator;
					if (sep != null) {
						base.NotifyGroupChanging(this,sep);
					}
					row = this.view[((BaseComparer)base.IndexList[value]).ListIndex];
				}
			}
			*/
		}
		
		#endregion
		
		#region IDisposable
		
		public override  void Dispose(){
			this.Dispose(true);
			GC.SuppressFinalize(this);
		}
		
		protected override void Dispose(bool disposing){
			try {
				if (disposing) {
					if (this.view != null) {
						this.view.Dispose();
						this.view = null;
					}
				}
			} finally {
				// Release unmanaged resources.
				// Set large fields to null.
				// Call Dispose on your base class.
				base.Dispose(disposing);
			}
			
		}
		#endregion
		
	}
}
